from json.tool import main
from socket import if_nameindex
from tkinter import E
import matplotlib.pyplot as plt
import pandas as pd
import seaborn as sns
import csv
import subprocess
import sys
import os
import json
from tqdm import tqdm

def writeCSV(fileName, data):
    with open(fileName, "w") as outfile:
        writer = csv.writer(outfile)
        writer.writerow(data.keys())
        writer.writerows(zip(*data.values()))

# Plot results of EVO, AutoMoDe and the 10 Autodemo experiments

if __name__ == '__main__':
    mission = sys.argv[1]
    data = {}
    evoScore = []
    automodeScore = []
    autodemoScore = []
    
    result_path = f"results/result_{mission}.md"
    with open(result_path, "r") as f:
        lines = f.readlines()
        for i in range(2, len(lines)):
            line = lines[i].split(" | ")
            if(line[-2] == "evostick"):
                evoScore.append(float(line[-1]))
            elif(line[-2] == "automode"):
                automodeScore.append(float(line[-1]))
            else:
                autodemoScore.append(float(line[-1]))
           
    data["Objective-evo"] = evoScore
    data["Objective-cho"] = automodeScore
    data["Demonstration-cho"] = autodemoScore  

    # Plotting boxplots
    df = pd.DataFrame(data=data)

    x = sns.boxplot(data=df,
                    palette='Set3',
                    linewidth=1.2,
                    fliersize=2,
                    order=list(df.columns),
                    flierprops=dict(marker='o', markersize=4),
                    notch=True)

    title = f'Score on {mission} mission for Objective-evo, Objective-cho and Demonstration-cho'
    plt.title(title, fontsize=18, pad=10)
    plt.ylabel("score")
    plt.xlabel("experiments")

    plt.show()


