import numpy as np; np.random.seed(0)
import seaborn as sns; sns.set_theme()
import matplotlib.pyplot as plt
import json
import pandas as pd
from matplotlib.pyplot import figure
import matplotlib
import colormap as cm

matplotlib.rcParams['figure.figsize'] = 1024/130, 945/130
matplotlib.rcParams['pdf.fonttype'] = 42
matplotlib.rcParams['ps.fonttype'] = 42
matplotlib.rcParams['font.family'] = 'serif'

fig, (ax1,ax2,ax3,ax4) = plt.subplots(ncols=4)



# Homing
mission = "homing"
date = "01-07-22"
w = []
colormap=sns.diverging_palette(250, 30, l=65, center="light", as_cmap=True)
colormap=matplotlib.cm.get_cmap('RdYlBu_r')
c = cm.colors.Colormap()
mycmap = c.cmap_linear('#0035ff', '#fcdb58', '#c61403')
colormap=mycmap
colormap=matplotlib.cm.get_cmap('RdYlBu_r')

for i in range(10):
        path = f"JSON/{mission}_{date}/{mission}_{date}_{i+1}.json"
        dictionary = json.load(open(path, 'r'))[-1]["w"]
        w.append([float(i)/sum(dictionary) for i in dictionary])

a = np.array(w)
res = np.sum(a, 0)
norm = np.array([float(i)/10 for i in res])
h1 = sns.heatmap(res.reshape(len(a[0]), 1), center=0, ax=ax1, cmap=colormap, yticklabels=5, xticklabels=False)
cbar1 = h1.collections[0].colorbar
cbar1.ax.set_yticklabels(cbar1.ax.get_yticklabels(), rotation=90, va='center')
ax1.invert_yaxis()
ax1.set_ylabel("Black region (0-19)                              Neighbor (20-39)",  fontsize=12) #homing
ax1.set_xlabel("Homing", rotation=180, variant = 'small-caps') 
ax1.tick_params(axis='y', pad=-1)


# AAC
mission = "aac"
date = "01-07-22"
w = []

for i in range(10):
        path = f"JSON/{mission}_{date}/{mission}_{date}_{i+1}.json"
        dictionary = json.load(open(path, 'r'))[-1]["w"]
        w.append([float(i)/sum(dictionary) for i in dictionary])

a = np.array(w)
res = np.sum(a, 0)
norm = np.array([float(i)/10 for i in res])
h2 = sns.heatmap(res.reshape(len(a[0]), 1), center=0, ax=ax2, cmap=colormap, yticklabels=5, xticklabels=False)
cbar2 = h2.collections[0].colorbar
cbar2.ax.set_yticklabels(cbar2.ax.get_yticklabels(), rotation=90, va='center')
ax2.invert_yaxis()
ax2.set_ylabel("White region (0-19)          Black region (20-39)          Neighbor (40-59)",  fontsize=12) #aac
ax2.set_xlabel(f"AAC", rotation=180)
ax2.tick_params(axis='y', pad=-1)


#SAC
mission = "shelter"
date = "01-07-22"
w = []

for i in range(10):
        path = f"JSON/{mission}_{date}/{mission}_{date}_{i+1}.json"
        dictionary = json.load(open(path, 'r'))[-1]["w"]
        w.append([float(i)/sum(dictionary) for i in dictionary])

a = np.array(w)
res = np.sum(a, 0)
norm = np.array([float(i)/10 for i in res])
h3 = sns.heatmap(res.reshape(len(a[0]), 1), center=0, ax=ax3, cmap=colormap, yticklabels=5, xticklabels=False)
cbar3 = h3.collections[0].colorbar
cbar3.ax.set_yticklabels(cbar3.ax.get_yticklabels(), rotation=90, va='center')
ax3.invert_yaxis()
ax3.set_xlabel(f"SAC", rotation=180)
ax3.set_ylabel("White region (0-19)             Black regions (20-79)              Neighbor (80-99)",  fontsize=12) #sac
ax3.tick_params(axis='y', pad=-1)

#CFA
mission = "forbid"
date = "01-07-22"
w = []

for i in range(10):
        path = f"JSON/{mission}_{date}/{mission}_{date}_{i+1}.json"
        dictionary = json.load(open(path, 'r'))[-1]["w"]
        w.append([float(i)/sum(dictionary) for i in dictionary])

a = np.array(w)
res = np.sum(a, 0)
norm = np.array([float(i)/10 for i in res])
h4 = sns.heatmap(res.reshape(len(a[0]), 1), center=0, ax=ax4, cmap=colormap, yticklabels=5, xticklabels=False)
cbar4 = h4.collections[0].colorbar
cbar4.ax.set_yticklabels(cbar4.ax.get_yticklabels(), rotation=90, va='center')
ax4.invert_yaxis()
ax4.set_xlabel(f"CFA", rotation=180)
ax4.set_ylabel("                              Black regions (0-59)                              Neighbor (60-79)",  fontsize=12)
ax4.tick_params(axis='y', pad=-1)




#plt.ylabel("Black circle (0-19)                              Neighbor (20-39)",  fontsize=15) #homing
#plt.ylabel("                              Black circles (0-59)                                   Neighbor (60-79)",  fontsize=15) #CFA
#plt.ylabel("White circle (0-19)          Black circle (20-39)          Neighbor (40-59)",  fontsize=15) #aac
#plt.ylabel("White rectangle (0-19)                                        Black rectangles (20-79)                                   Neighbor (80-99)",  fontsize=10) #sac
#plt.ylabel("Neighbor (80-100)          Black rectangle (60-79)          White Rectangle (40-59)          Black circle (20-39)          White rectangles (0-19)",  fontsize=8)
plt.tight_layout(pad=2)
matplotlib.pyplot.savefig("heatmaps.pdf")
plt.show()
